<?php

namespace FiloBlu\AdminSecurity\Api;

/**
 * @SuppressWarnings(PHPMD.ShortVariable)
 */
interface TrustedRepositoryInterface
{
    /**
     * Save object
     * @param \FiloBlu\AdminSecurity\Api\Data\TrustedInterface $object
     * @return \FiloBlu\AdminSecurity\Api\Data\TrustedInterface
     */
    public function save(\FiloBlu\AdminSecurity\Api\Data\TrustedInterface $object);

    /**
     * Get object by id
     * @param int $id
     * @return \FiloBlu\AdminSecurity\Api\Data\TrustedInterface
     */
    public function getById($id);

    /**
     * Get by UserId value
     * @param int $value
     * @return \FiloBlu\AdminSecurity\Api\Data\TrustedInterface
     */
    public function getByUserId($value);

    /**
     * Delete object
     * @param \FiloBlu\AdminSecurity\Api\Data\TrustedInterface $object
     * @return boolean
     */
    public function delete(\FiloBlu\AdminSecurity\Api\Data\TrustedInterface $object);

    /**
     * Get a list of object
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \FiloBlu\AdminSecurity\Api\Data\TrustedSearchResultsInterface
     */
    public function getList(\Magento\Framework\Api\SearchCriteriaInterface $searchCriteria);
}
