<?php

namespace FiloBlu\AdminSecurity\Plugin\Controller\Adminhtml\User;

use Magento\Backend\Controller\Adminhtml\Auth\Login;
use Magento\Backend\Model\Auth\Session;
use Magento\Backend\Model\View\Result\Redirect;

class BeforeLogin
{
    /**
     * @var Session
     */
    protected $authStorage;

    /**
     * @var Redirect
     */
    protected $resultRedirectFactory;

    /**
     * BeforeLogin constructor.
     *
     * @param Session $authStorage
     * @param Redirect $resultRedirectFactory
     */
    public function __construct(
        Session        $authStorage,
        Redirect $resultRedirectFactory
    )
    {
        $this->authStorage = $authStorage;
        $this->resultRedirectFactory = $resultRedirectFactory;
    }

    /**
     * Redirect to verification form
     *
     * @param Login $object
     * @param callable $proceed
     */
    public function aroundExecute(Login $object, callable $proceed)
    {
        if ($this->authStorage->getNeedVerification()) {
            $resultRedirect = $this->resultRedirectFactory;
            $resultRedirect->setPath('filobluas/auth/resetpassword');
            return $resultRedirect;
        }
        return $proceed();
    }
}
